#include "vector.h"
#include <iostream>

using namespace std;

Vector::Vector(int size)
{
	this -> size = size;
	this -> data = new double[size];
}

Vector::Vector(Vector &v2)
{
	size = v2.size;
	data = new double[size];
	int i;
	for(i=0; i<size; i++)
		data[i] = v2.data[i];
}

Vector::~Vector()
{
	delete [] data;
}

int Vector::get_size()
{
	return size;
}

void Vector::set_size(int newsize)
{
	double *newdata = new double[newsize];
	for(int i=0; i<size && i<newsize ; i++)
		newdata[i] = data[i];
	delete [] data;
	data = newdata;
	size = newsize;
	return;
}

double Vector::read_element(int index)
{
	return data[index];
}

void Vector::write_element(int index, double e)
{
	data[index] = e;
}

ostream& operator<<(ostream & o, Vector &v)
{
	for(int i=0; i<v.size; i++)
		o << v.read_element(i) << ", ";
	o << endl;
	return o;
}

Vector & Vector::operator=(Vector &v2)
{
	int i;
	delete [] data;
	size = v2.size;
	data = new double[size];
	for(i=0; i<size; i++)
		data[i] = v2.data[i];
	return *this;
}

double & Vector::operator[](int index)
{
	return data[index];
}
